"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from typing import Optional
from typing_extensions import NotRequired, TypedDict
from zendesk.types import BaseModel


class DeliveryStatusTypedDict(TypedDict):
    r"""Details about the delivery status"""

    code: NotRequired[str]
    r"""The delivery status code (SMTP code and DSN code)"""
    id: NotRequired[int]
    r"""The delivery status id"""
    message: NotRequired[str]
    r"""The delivery status description"""
    name: NotRequired[str]
    r"""The delivery status type (key)"""


class DeliveryStatus(BaseModel):
    r"""Details about the delivery status"""

    code: Optional[str] = None
    r"""The delivery status code (SMTP code and DSN code)"""

    id: Optional[int] = None
    r"""The delivery status id"""

    message: Optional[str] = None
    r"""The delivery status description"""

    name: Optional[str] = None
    r"""The delivery status type (key)"""


class RecipientObjectTypedDict(TypedDict):
    delivery_status: NotRequired[DeliveryStatusTypedDict]
    r"""Details about the delivery status"""
    email_address: NotRequired[str]
    r"""The recipient's email address"""
    user_id: NotRequired[int]
    r"""The recipient's user id"""


class RecipientObject(BaseModel):
    delivery_status: Optional[DeliveryStatus] = None
    r"""Details about the delivery status"""

    email_address: Optional[str] = None
    r"""The recipient's email address"""

    user_id: Optional[int] = None
    r"""The recipient's user id"""
