"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from typing import Optional
from typing_extensions import NotRequired, TypedDict
from zendesk.types import BaseModel


class SatisfactionReasonObjectTypedDict(TypedDict):
    value: str
    r"""Translated value of the reason in the account locale"""
    created_at: NotRequired[datetime]
    r"""The time the reason was created"""
    deleted_at: NotRequired[datetime]
    r"""The time the reason was deleted"""
    id: NotRequired[int]
    r"""Automatically assigned upon creation"""
    raw_value: NotRequired[str]
    r"""The dynamic content placeholder, if present, or the current \"value\", if not. See [Dynamic Content Items](/api-reference/ticketing/ticket-management/dynamic_content/)"""
    reason_code: NotRequired[int]
    r"""An account-level code for referencing the reason. Custom reasons are assigned an auto-incrementing integer (non-system reason codes begin at 1000). See [Reason codes](#reason-codes)"""
    updated_at: NotRequired[datetime]
    r"""The time the reason was updated"""
    url: NotRequired[str]
    r"""API URL for the resource"""


class SatisfactionReasonObject(BaseModel):
    value: str
    r"""Translated value of the reason in the account locale"""

    created_at: Optional[datetime] = None
    r"""The time the reason was created"""

    deleted_at: Optional[datetime] = None
    r"""The time the reason was deleted"""

    id: Optional[int] = None
    r"""Automatically assigned upon creation"""

    raw_value: Optional[str] = None
    r"""The dynamic content placeholder, if present, or the current \"value\", if not. See [Dynamic Content Items](/api-reference/ticketing/ticket-management/dynamic_content/)"""

    reason_code: Optional[int] = None
    r"""An account-level code for referencing the reason. Custom reasons are assigned an auto-incrementing integer (non-system reason codes begin at 1000). See [Reason codes](#reason-codes)"""

    updated_at: Optional[datetime] = None
    r"""The time the reason was updated"""

    url: Optional[str] = None
    r"""API URL for the resource"""
