"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .searchresultobject import SearchResultObject, SearchResultObjectTypedDict
from pydantic import model_serializer
from typing import List, Optional
from typing_extensions import NotRequired, TypedDict
from zendesk.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL


class SearchResponseTypedDict(TypedDict):
    count: NotRequired[int]
    r"""The number of resources returned by the query corresponding to this page of results in the paginated response"""
    facets: NotRequired[Nullable[str]]
    r"""The facets corresponding to the search query"""
    next_page: NotRequired[Nullable[str]]
    r"""URL to the next page of results"""
    previous_page: NotRequired[Nullable[str]]
    r"""URL to the previous page of results"""
    results: NotRequired[List[SearchResultObjectTypedDict]]
    r"""May consist of tickets, users, groups, or organizations, as specified by the `result_type` property in each result object"""


class SearchResponse(BaseModel):
    count: Optional[int] = None
    r"""The number of resources returned by the query corresponding to this page of results in the paginated response"""

    facets: OptionalNullable[str] = UNSET
    r"""The facets corresponding to the search query"""

    next_page: OptionalNullable[str] = UNSET
    r"""URL to the next page of results"""

    previous_page: OptionalNullable[str] = UNSET
    r"""URL to the previous page of results"""

    results: Optional[List[SearchResultObject]] = None
    r"""May consist of tickets, users, groups, or organizations, as specified by the `result_type` property in each result object"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["count", "facets", "next_page", "previous_page", "results"]
        nullable_fields = ["facets", "next_page", "previous_page"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
