"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from typing import Any, Dict, Optional
from typing_extensions import NotRequired, TypedDict
from zendesk.types import BaseModel


class ViewObjectTypedDict(TypedDict):
    active: NotRequired[bool]
    r"""Whether the view is active"""
    conditions: NotRequired[Dict[str, Any]]
    r"""Describes how the view is constructed. See [Conditions reference](/documentation/ticketing/reference-guides/conditions-reference)"""
    created_at: NotRequired[datetime]
    r"""The time the view was created"""
    default: NotRequired[bool]
    r"""If true, the view is a default view"""
    description: NotRequired[str]
    r"""The description of the view"""
    execution: NotRequired[Dict[str, Any]]
    r"""Describes how the view should be executed. See [Execution](#execution)"""
    id: NotRequired[int]
    r"""Automatically assigned when created"""
    position: NotRequired[int]
    r"""The position of the view"""
    restriction: NotRequired[Dict[str, Any]]
    r"""Who may access this account. Is null when everyone in the account can access it"""
    title: NotRequired[str]
    r"""The title of the view"""
    updated_at: NotRequired[datetime]
    r"""The time the view was last updated"""


class ViewObject(BaseModel):
    active: Optional[bool] = None
    r"""Whether the view is active"""

    conditions: Optional[Dict[str, Any]] = None
    r"""Describes how the view is constructed. See [Conditions reference](/documentation/ticketing/reference-guides/conditions-reference)"""

    created_at: Optional[datetime] = None
    r"""The time the view was created"""

    default: Optional[bool] = None
    r"""If true, the view is a default view"""

    description: Optional[str] = None
    r"""The description of the view"""

    execution: Optional[Dict[str, Any]] = None
    r"""Describes how the view should be executed. See [Execution](#execution)"""

    id: Optional[int] = None
    r"""Automatically assigned when created"""

    position: Optional[int] = None
    r"""The position of the view"""

    restriction: Optional[Dict[str, Any]] = None
    r"""Who may access this account. Is null when everyone in the account can access it"""

    title: Optional[str] = None
    r"""The title of the view"""

    updated_at: Optional[datetime] = None
    r"""The time the view was last updated"""
